#property copyright "Konstantin Sokolov"
#property link      "http://marketiva.svoi.info"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red

extern double step = 0.02;
extern double AFmax = 0.2;

int sing = 1;
double calculatedStep;
double high;
double low;
double buf[];

int init() {
  SetIndexStyle(0, DRAW_LINE);
  SetIndexBuffer(0, buf);
  return (0);
}

int deinit() {
  return 0;
}

int start() {
  for (int i = Bars - 2; i >= 0; i--) {
    if (i == Bars - 2) {
      Print("i = ", i);
      buf[i] = Low[i] - 10.0 * Point;
      sing = 1;
      calculatedStep = step;
      high = High[i];
      low = Low[i];
    } else {
      if (Close[i] > high) {
        Print("high = ", high);
        high = Close[i];
        if (sing == 1 && calculatedStep <= AFmax - step) {
          calculatedStep += step;
        }
      }
      if (Close[i] < low) {
        Print("low = ", low);
        low = Close[i];
        if (sing == -1 && calculatedStep <= AFmax - step) {
          calculatedStep += step;
        }
      }
      if (sing == 1)
        buf[i] = buf[i + 1] + calculatedStep * (high - (buf[i + 1]));
      else
        buf[i] = buf[i + 1] + calculatedStep * (low - (buf[i + 1]));
      if ((buf[i + 1] < Close[i + 1] && buf[i] > Close[i]) || (buf[i + 1] > Close[i + 1] && buf[i] < Close[i])) {
        calculatedStep = step;
        if (sing == 1)
          buf[i] = high;
        else
          buf[i] = low;
        low = Close[i];
        high = Close[i];
        sing = -1 * sing;
      }
    }
  }
  return 0;
}
